local function register(name, self)
	register_anything_actor(name, self)
end

return Def.ActorFrame{
  Name= "actor_dh",
  Def.Actor{
    Name= "actor_eh",
    OnCommand= cmd(sleep,99999999),
  },
  Def.ActorFrame{
    Name= "actor_fh",
    Def.Sprite{
      Name= "actor_gh",
      InitCommand= function(self)
				register("chen_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "oh1.png",
    },
    Def.Sprite{
      Name= "actor_hh",
      InitCommand= function(self)
				register("ran_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "oh2.png",
    },
    Def.Sprite{
      Name= "actor_ih",
      InitCommand= function(self)
				register("yeah_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);

			end,
      OnCommand= cmd(),
      Texture= "yeah.png",
    },
    Def.Sprite{
      Name= "actor_jh",
      InitCommand= function(self)
				register("luna_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "luna.png",
    },
    Def.Sprite{
      Name= "actor_kh",
      InitCommand= function(self)
				register("saph_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "saph.png",
    },
    Def.Sprite{
      Name= "actor_lh",
      InitCommand= function(self)
				register("sunny_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "sunny.png",
    },
    Def.Sprite{
      Name= "actor_mh",
      InitCommand= function(self)
				register("pa", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
				self:bob();
				self:effectperiod(0.3);
				self:effectmagnitude(10,0,0);
				self:blend('Add');
			end,
      Texture= "pa.png",
    },
    Def.Sprite{
      Name= "actor_nh",
      InitCommand= function(self)
				register("pi", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
				self:bob();
				self:effectperiod(0.3);
				self:effectmagnitude(10,0,0);
				self:blend('Add');
				
			end,
      Texture= "pi.png",
    },
    Def.Sprite{
      Name= "actor_oh",
      InitCommand= function(self)
				register("pu", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
				self:bob();
				self:effectperiod(0.3);
				self:effectmagnitude(10,0,0);
				self:blend('Add');
			end,
      Texture= "pu.png",
    },
    Def.Sprite{
      Name= "actor_ph",
      InitCommand= function(self)
				register("glass_anim", self)
				self:x(9999);
				self:y(9999);
				self:zoom(0);
				self:diffusealpha(0);
			end,
      OnCommand= cmd(),
      Texture= "crack1.png",
    },
    Def.Quad{
      Name= "actor_qh",
      InitCommand= function(self)
				register("color_tile", self)
			end,
      OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffusealpha,0;blend,"BlendMode_Add"),
    },
    Def.Quad{
      Name= "actor_rh",
      InitCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('#000000');diffusealpha,0),
    },
  },
  Def.ActorFrame{
    Name= "actor_sh",
    Def.Sprite{
      Name= "actor_th",
      InitCommand= function(self) register("snow1", self) self:texcoordvelocity(0.1,-0.7); self:x(320); self:y(240); self:zoomto(SCREEN_WIDTH,SCREEN_HEIGHT); self:diffusealpha(0); end,
      OnCommand= cmd(),
      Texture= "far.png",
    },
    Def.Sprite{
      Name= "actor_uh",
      InitCommand= function(self) register("snow2", self) self:texcoordvelocity(0.2,-0.4); self:x(320); self:y(240); self:zoomto(SCREEN_WIDTH,SCREEN_HEIGHT); self:diffusealpha(0); end,
      OnCommand= cmd(),
      Texture= "med.png",
    },
    Def.Sprite{
      Name= "actor_vh",
      InitCommand= function(self) register("snow3", self) self:texcoordvelocity(0.3,-0.2); self:x(320); self:y(240); self:zoomto(SCREEN_WIDTH,SCREEN_HEIGHT); self:diffusealpha(0); end,
      OnCommand= cmd(),
      Texture= "low.png",
    },
  },
}
