local cur_fg = 1
local cx = SCREEN_CENTER_X
local cy = SCREEN_CENTER_Y
local cur_anim = 0
local vib_ctrl = 0
local oscillate = 1
local bump_ctrl = {0,0,0,0}
local curmod = 1
local song= GAMESTATE:GetCurrentSong()
local path = song:GetSongDir()

local anything_actors= {}

function register_anything_actor(name, act)
	anything_actors[name]= act
end

local poptions= {}

-- FromString added to 5.0 2016/09/16. -Kyz
local function mod_both(mod_str)
	for pn, ops in pairs(poptions) do
		ops:FromString(mod_str)
	end
end

local screen_gameplay= false

koishi_dialog = {
	'I guess Cirno doesn\'t \n\n know it\'s spring, yet.',
	'I guess Cirno doesn\'t \n\n know it\'s sping, yet.',
	'Very funny, Cirno.',
	'Is it just me or does \n\n this place fucking SUCK!',
	'I\'m tired as fuck.',
	'Does Cirno ever quit it \n\n with the god damn \n\n SNOW??',
	'What idiot came up with calling SONGMAN:FindSong to get the current song?',
	'Do any gimmick authors understand that everything is a table?',
}

local mods = {
	{0.000,'*10000 overhead,*10000 2.3x'},
	
	{7.500,'*7 reverse'},
	{8.000,'*7 0 reverse'},
	
	{10.000,'*7 split'},
	{10.750,'*7 0 split,*7 reverse'},
	{11.500,'*7 0 reverse'},
	
	{18.000,'*3 200 mini,*1 50 drunk'},
	{20.000,'*10000 70 mini,*30 -250 centered'},
	
	{23.500,'*30 0 centered'},
	{24.000,'*30 -250 centered,*10000 reverse'},
	
	{27.500,'*30 0 centered'},
	{28.000,'*30 -250 centered,*10000 no reverse'},
	
	{31.500,'*30 200 mini,*30 0 centered'},
	{32.000,'*1.7 0 mini,*1 50 drunk'},
	
	{35.500,'*10000 beat'},
	
	{52.000,'*30 -200 centered,*10 70 mini,*3 3x'},
	
	{64.000,'*2 0 centered,*1 0 mini,*1 2.3x'},
	
	{67.500,'*10000 0 beat'},
	{68.000,'*1 50 stealth,*0.1 100 tornado'},
	{68.000,'*5 5 reverse'},
	{68.500,'*5 10 reverse'},
	{69.000,'*5 15 reverse'},
	{69.500,'*5 20 reverse'},
	{70.000,'*5 25 reverse'},
	{70.500,'*5 30 reverse'},
	{71.000,'*5 35 reverse'},
	{71.500,'*5 40 reverse'},
	{72.000,'*1 0 stealth,*0.5 0 tornado,*0.5 0 reverse'},
	
	{72.000,'*100000 2000 dizzy'},
	{72.100,'*17 0 dizzy'},
	
	{74.000,'*2.8 200 mini,*1 0 drunk,*1 50 tipsy'},
	{76.000,'*10000 70 mini,*30 -250 centered'},
	
	{79.500,'*30 0 centered'},
	{80.000,'*30 -250 centered,*10000 reverse'},
	
	{83.500,'*30 0 centered'},
	{84.000,'*30 -250 centered,*10000 0 reverse'},
	
	{87.500,'*30 200 mini,*30 0 centered'},
	{88.000,'*1.7 0 mini,*1 0 drunk,*0 wave,*1 bumpy'},
	
	{91.500,'*10000 beat'},
	
	{95.500,'*7 split'},
	{96.000,'*7 0 split,*7 reverse'},
	
	{98.000,'*7 split,*7 reverse'},
	{98.750,'*7 0 split,*100000 0 reverse'},
	{99.500,'*7 split'},
	{100.000,'*7 0 split,*7 reverse'},
	
	{103.500,'*5 0 reverse'},
	
	{104.000,'*10 -200 centered,*5 50 stealth,*5 70 dark'},
	
	{107.000,'*3 -30 flip'},
	
	{108.000,'*10000 0 beat,*3 0 flip,*5 0 mini,*10 0 centered,*5 0 stealth,*5 0 dark'},
	
	{111.500,'*10 flip'},
	{112.000,'*10 0 flip'},
	
	{114.000,'*7 reverse'},
	{114.750,'*7 0 reverse'},
	{115.500,'*9 reverse'},
	{115.000,'*9 0 reverse'},
	
	{124.000,'*0.8 stealth,*1 150 hallway'},
	{128.000,'*0.8 0 stealth,*2 -150 hallway'},
	{132.000,'*0.8 stealth,*2 150 hallway'},
	{136.000,'*0.8 0 stealth,*2 -150 hallway'},
	{140.000,'*0.8 stealth,*2 150 hallway'},
	{144.000,'*0.8 0 stealth,*1 0 hallway'},
	
	{148.000,'*10000 200 drunk,*10000 200 tipsy'},
	{148.100,'*5 0 drunk,*5 0 tipsy'},
	
	{150.000,'*10000 -200 drunk,*10000 -200 tipsy,*5 -65 flip'},
	{150.100,'*5 0 drunk,*5 0 tipsy'},
	
	{152.000,'*10000 200 drunk,*10000 200 tipsy'},
	{152.100,'*5 0 drunk,*5 0 tipsy'},
	
	{154.00,'*1 0 flip'},
	
	{156.000,'*10000 -50 mini'},
	{156.100,'*4 0 mini'},
	{156.500,'*10000 -50 mini'},
	{156.600,'*4 0 mini'},
	{157.000,'*10000 -50 mini'},
	{157.100,'*4 0 mini'},
	{157.500,'*10000 -50 mini'},
	{157.600,'*4 0 mini'},
	{158.000,'*10000 -50 mini'},
	{158.100,'*4 0 mini'},
	{158.500,'*10000 -50 mini'},
	{158.600,'*4 0 mini'},
	
	{159.000,'*10 200 tipsy'},
	{159.250,'*20 -200 tipsy'},
	{159.500,'*20 200 tipsy'},
	{159.750,'*20 -200 tipsy'},
	{160.000,'*10 0 tipsy'},
	
	{160.500,'*10 200 drunk'},
	{160.750,'*20 -200 drunk'},
	{161.000,'*20 200 drunk'},
	{161.250,'*20 -200 drunk'},
	{161.500,'*20 200 drunk'},
	{161.750,'*20 -200 drunk'},
	{162.000,'*20 200 drunk'},
	{162.250,'*20 -200 drunk'},
	{162.500,'*20 200 drunk'},
	{162.750,'*20 -200 drunk'},
	{163.000,'*20 200 drunk'},
	{163.250,'*20 -200 drunk'},
	{163.500,'*20 200 drunk,*10000 beat'},
	{163.750,'*10 0 drunk'},
	
	{164.000,'*1 70 dark'},
	
	{188.350,'*5 25 flip'},
	{188.850,'*5 50 flip'},
	{189.350,'*5 75 flip'},
	{189.850,'*5 100 flip'},
	{190.350,'*5 75 flip'},
	{190.850,'*5 50 flip'},
	{191.350,'*5 25 flip'},
	{191.850,'*5 0 flip'},
	
	{192.000,'*1 50 stealth,*0.3 100 tornado'},
	{196.000,'*1 0 stealth,*0.5 0 tornado,*10000 2000 dizzy'},
	{196.100,'*10 0 dizzy'},
	
	{220.350,'*5 25 reverse'},
	{220.850,'*5 50 reverse'},
	{221.350,'*5 75 reverse'},
	{221.850,'*5 100 reverse'},
	{222.350,'*5 75 reverse'},
	{222.850,'*5 50 reverse'},
	{223.350,'*5 25 reverse'},
	{223.850,'*5 0 reverse'},
	
	{227.500,'*100000 0 beat,*1 0 bumpy'},
	{228.000,'*1 10 flip,*5 -100 mini,*4 2x,*1 0 dark'},
	{232.000,'*1 25 flip,*5 -200 mini,*4 1.5x'},
	{236.000,'*1 35 flip,*8 -400 mini,*4 1x'},
	
	{240.000,'*0.2 0 flip,*2.5 0 mini,*2 2.3x'},
	
	{247.500,'*7 reverse'},
	{248.000,'*7 0 reverse'},
	
	{250.000,'*7 split'},
	{250.750,'*7 0 split,*7 reverse'},
	{251.500,'*7 0 reverse'},
	
	{258.000,'*3 200 mini,*1 50 drunk'},
	{260.000,'*10000 70 mini,*30 -250 centered'},
	
	{263.500,'*30 0 centered'},
	{264.000,'*30 -250 centered,*10000 reverse'},
	
	{267.500,'*30 0 centered'},
	{268.000,'*30 -250 centered,*10000 no reverse'},
	
	{271.500,'*30 200 mini,*30 0 centered'},
	{272.000,'*1.7 0 mini,*1 0 drunk'},
}

local cura = 1
local anything = {
	
	---------------------------
	{3.000},
	
	{0,'P1','accelerate',0.35},
	{0,'P1','zoomx',0},
	{0,'P1','bounceend',0.3},
	{0,'P1','zoomx',1},
	
	{0,'P2','accelerate',0.35},
	{0,'P2','zoomx',0},
	{0,'P2','bounceend',0.3},
	{0,'P2','zoomx',1},

	---------------------------
	---------------------------
	{4.000},
	
	
	{0,'misty_lake','visible',false},
	
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',1,0,0,0.4},
	{0,'screen','decelerate',0.2},
	{0,'screen','zoom',0.7},
	{0,'screen','rotationz',25},

	---------------------------
	---------------------------
	{8.000},
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',0,0,1,0.4},
	{0,'screen','decelerate',0.2},
	{0,'screen','zoom',0.4},
	{0,'screen','rotationz',-25},

	---------------------------
	---------------------------
	{12.000},
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',0,1,0,0.4},
	{0,'screen','decelerate',0.2},
	{0,'screen','zoom',0.2},
	{0,'screen','rotationz',25},

	---------------------------
	---------------------------
	{15.500},
	{0,'color_tile','decelerate',0.2},
	{0,'color_tile','diffuse',1,1,1,0},
	{0,'screen','decelerate',0.187},
	{0,'screen','rotationz',0},
	{0,'screen','decelerate',0.7},
	{0,'screen','zoom',1},

	---------------------------
	
	---------------------------
	{18.000},

	{0,'misty_lake','visible',true},
	
	{0,'bg_anim','linear',1},
	{0,'bg_anim','faderight',1},
	{0,'bg_anim','cropright',1},
	---------------------------
	
	---------------------------
	{20.000},

	{0,'pa','diffusealpha',1},
	{0,'pa','zoom',1},
	{0,'pa','x',480},
	{0,'pa','y',300},
	{0,'pa','decelerate',1},
	{0,'pa','addy',100},
	{0,'pa','diffusealpha',0},
	
	{0,'chen_anim','x',480},
	{0,'chen_anim','y',-200},
	{0,'chen_anim','rotationz',180},
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','zoom',0.8},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',50},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-200},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	{0,'P1','rotationz',25},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	{0,'P2','rotationz',25},

	---------------------------
	---------------------------
	{23.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-250},
	
	---------------------------
	---------------------------
	{24.000},
	
	{0,'pi','diffusealpha',1},
	{0,'pi','zoom',1},
	{0,'pi','x',160},
	{0,'pi','y',200},
	{0,'pi','decelerate',1},
	{0,'pi','addy',-100},
	{0,'pi','diffusealpha',0},
	
	{0,'chen_anim','x',160},
	{0,'chen_anim','y',680},
	{0,'chen_anim','rotationz',0},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',400},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',220},
	
	{0,'P1','x',640},
	{0,'P1','y',SCREEN_TOP-240},
	
	{0,'P2','x',640},
	{0,'P2','y',SCREEN_TOP-240},
	

	---------------------------
	---------------------------
	{27.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',250},
	
	---------------------------
	---------------------------
	{28.000},
	
	{0,'pu','diffusealpha',1},
	{0,'pu','zoom',1},
	{0,'pu','x',480},
	{0,'pu','y',300},
	{0,'pu','decelerate',1},
	{0,'pu','addy',100},
	{0,'pu','diffusealpha',0},
	
	{0,'chen_anim','x',480},
	{0,'chen_anim','y',-200},
	{0,'chen_anim','rotationz',180},
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','zoom',0.8},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',50},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','addy',-200},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	---------------------------
	---------------------------
	{31.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-250},
	
	---------------------------
	---------------------------
	{32.000},
	
	{0,'P1','x',160},
	{0,'P1','y',240},
	{0,'P1','decelerate',1},
	{0,'P1','rotationz',0},
	
	{0,'P2','x',480},
	{0,'P2','y',240},
	{0,'P2','decelerate',1},
	{0,'P2','rotationz',0},

	---------------------------
	---------------------------
	{39.500},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',2},
	{0,'P1','x',320},
	{0,'P1','sleep',0.094},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',1},
	{0,'P1','x',480},
	
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',2},
	{0,'P2','x',320},
	{0,'P2','sleep',0.094},
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',1},
	{0,'P2','x',160},


	---------------------------
	---------------------------
	{42.000},
	{0,'P1','decelerate',0.188},
	{0,'P1','zoomx',2},
	{0,'P1','x',320},
	{0,'P1','decelerate',0.188},
	{0,'P1','zoomx',1},
	{0,'P1','x',160},
	{0,'P1','sleep',0.094},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',2},
	{0,'P1','x',320},
	{0,'P1','sleep',0.094},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',1},
	{0,'P1','x',480},
	
	{0,'P2','decelerate',0.188},
	{0,'P2','zoomx',2},
	{0,'P2','x',320},
	{0,'P2','decelerate',0.188},
	{0,'P2','zoomx',1},
	{0,'P2','x',480},
	{0,'P2','sleep',0.094},
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',2},
	{0,'P2','x',320},
	{0,'P2','sleep',0.094},
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',1},
	{0,'P2','x',160},


	---------------------------
	---------------------------
	{47.500},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',2},
	{0,'P1','x',320},
	{0,'P1','sleep',0.094},
	{0,'P1','linear',0.094},
	{0,'P1','zoomx',1},
	{0,'P1','x',160},
	
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',2},
	{0,'P2','x',320},
	{0,'P2','sleep',0.094},
	{0,'P2','linear',0.094},
	{0,'P2','zoomx',1},
	{0,'P2','x',480},
	


	---------------------------
	---------------------------
	{48.000},
	
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','x',SCREEN_LEFT-200},
	{0,'chen_anim','y',SCREEN_CENTER_Y},
	{0,'chen_anim','zoom',1},
	{0,'chen_anim','rotationz',90},
	{0,'chen_anim','decelerate',0.3},
	{0,'chen_anim','addx',300},
	{0,'chen_anim','accelerate',0.3},
	{0,'chen_anim','addx',-300},
	{0,'chen_anim','sleep',0},
	{0,'chen_anim','diffusealpha',0},
	
	{0,'P1','wag'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',2},
	{0,'P1','effectmagnitude',0,0,30},
	
	{0,'P2','wag'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',2},
	{0,'P2','effectmagnitude',0,0,30},

	---------------------------
	---------------------------
	{49.000},
	
	{0,'ran_anim','diffusealpha',1},
	{0,'ran_anim','x',SCREEN_RIGHT+200},
	{0,'ran_anim','y',SCREEN_CENTER_Y},
	{0,'ran_anim','zoom',-1},
	{0,'ran_anim','rotationz',90},
	{0,'ran_anim','decelerate',0.3},
	{0,'ran_anim','addx',-300},
	{0,'ran_anim','accelerate',0.3},
	{0,'ran_anim','addx',300},
	{0,'ran_anim','sleep',0},
	{0,'ran_anim','diffusealpha',0},
	
	{0,'P1','effectmagnitude',0,0,60},
	{0,'P2','effectmagnitude',0,0,60},

	---------------------------
	---------------------------
	{50.000},
	
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','x',SCREEN_CENTER_X},
	{0,'chen_anim','y',SCREEN_TOP-200},
	{0,'chen_anim','zoom',1},
	{0,'chen_anim','rotationz',180},
	{0,'chen_anim','decelerate',0.3},
	{0,'chen_anim','addy',300},
	{0,'chen_anim','accelerate',0.3},
	{0,'chen_anim','addy',-300},
	{0,'chen_anim','sleep',0},
	{0,'chen_anim','diffusealpha',0},
	
	{0,'P1','effectmagnitude',0,0,90},
	{0,'P2','effectmagnitude',0,0,90},

	---------------------------
	---------------------------
	{51.000},
	
	{0,'ran_anim','diffusealpha',1},
	{0,'ran_anim','x',SCREEN_CENTER_X},
	{0,'ran_anim','y',SCREEN_BOTTOM+200},
	{0,'ran_anim','zoom',1},
	{0,'ran_anim','rotationz',0},
	{0,'ran_anim','decelerate',0.3},
	{0,'ran_anim','addy',-300},
	{0,'ran_anim','accelerate',0.3},
	{0,'ran_anim','addy',300},
	{0,'ran_anim','sleep',0},
	{0,'ran_anim','diffusealpha',0},
	
	{0,'P1','stopeffect'},
	{0,'P2','stopeffect'},
	
	{0,'P1','decelerate',0.5},
	{0,'P1','rotationz',-360},
	{0,'P1','sleep',0},
	{0,'P1','rotationz',0},
	
	{0,'P2','decelerate',0.5},
	{0,'P2','rotationz',-360},
	{0,'P2','sleep',0},
	{0,'P2','rotationz',0},

	---------------------------
	---------------------------
	{52.000},

	{0,'P1','decelerate',0.187},
	{0,'P1','x',320},
	{0,'P1','y',SCREEN_BOTTOM},
	{0,'P1','rotationz',-35},
	
	{0,'P2','decelerate',0.187},
	{0,'P2','x',320},
	{0,'P2','y',SCREEN_BOTTOM},
	{0,'P2','rotationz',35},

	---------------------------
	---------------------------
	{55.500},

	{0,'P1','decelerate',0.187},
	{0,'P1','rotationz',35},
	{0,'P1','decelerate',0.187},
	{0,'P1','rotationz',-35},
	
	{0,'P2','decelerate',0.187},
	{0,'P2','rotationz',-35},
	{0,'P2','decelerate',0.187},
	{0,'P2','rotationz',35},

	---------------------------
	{58.000},
	{0,'P1','decelerate',0.248},
	{0,'P1','rotationz',35},
	{0,'P1','decelerate',0.248},
	{0,'P1','rotationz',-35},
	{0,'P1','decelerate',0.188},
	{0,'P1','rotationz',35},
	{0,'P1','decelerate',0.188},
	{0,'P1','rotationz',-35},
	
	{0,'P2','decelerate',0.248},
	{0,'P2','rotationz',-35},
	{0,'P2','decelerate',0.248},
	{0,'P2','rotationz',35},
	{0,'P2','decelerate',0.188},
	{0,'P2','rotationz',-35},
	{0,'P2','decelerate',0.188},
	{0,'P2','rotationz',35},
	
	---------------------------
	{63.500},

	{0,'P1','decelerate',0.187},
	{0,'P1','rotationz',0},
	{0,'P1','linear',1},
	{0,'P1','x',160},
	{0,'P1','y',240},
	
	{0,'P2','decelerate',0.187},
	{0,'P2','rotationz',0},
	{0,'P2','linear',1},
	{0,'P2','x',480},
	{0,'P2','y',240},

	---------------------------
	
	---------------------------
	{76.000},
	
	{0,'pa','diffusealpha',1},
	{0,'pa','zoom',1},
	{0,'pa','x',480},
	{0,'pa','y',300},
	{0,'pa','decelerate',1},
	{0,'pa','addy',100},
	{0,'pa','diffusealpha',0},
	
	{0,'ran_anim','x',480},
	{0,'ran_anim','y',-250},
	{0,'ran_anim','rotationz',180},
	{0,'ran_anim','diffusealpha',1},
	{0,'ran_anim','zoom',0.8},
	{0,'ran_anim','bounceend',0.2},
	{0,'ran_anim','y',50},
	{0,'ran_anim','sleep',1.1},
	{0,'ran_anim','linear',0.1},
	{0,'ran_anim','addy',-200},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	{0,'P1','rotationz',25},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	{0,'P2','rotationz',25},

	---------------------------
	---------------------------
	{79.500},
	
	{0,'ran_anim','linear',0.1},
	{0,'ran_anim','addy',-250},
	
	---------------------------
	---------------------------
	{80.000},
	
	{0,'pi','diffusealpha',1},
	{0,'pi','zoom',1},
	{0,'pi','x',160},
	{0,'pi','y',200},
	{0,'pi','decelerate',1},
	{0,'pi','addy',-100},
	{0,'pi','diffusealpha',0},
	
	{0,'ran_anim','x',160},
	{0,'ran_anim','y',680},
	{0,'ran_anim','rotationz',0},
	{0,'ran_anim','bounceend',0.2},
	{0,'ran_anim','y',400},
	{0,'ran_anim','sleep',1.1},
	{0,'ran_anim','linear',0.1},
	{0,'ran_anim','addy',260},
	
	{0,'P1','x',640},
	{0,'P1','y',SCREEN_TOP-240},
	
	{0,'P2','x',640},
	{0,'P2','y',SCREEN_TOP-240},
	

	---------------------------
	---------------------------
	{83.500},
	
	{0,'ran_anim','linear',0.1},
	{0,'ran_anim','addy',250},
	
	---------------------------
	---------------------------
	{84.000},
	
	{0,'pu','diffusealpha',1},
	{0,'pu','zoom',1},
	{0,'pu','x',480},
	{0,'pu','y',300},
	{0,'pu','decelerate',1},
	{0,'pu','addy',100},
	{0,'pu','diffusealpha',0},
	
	{0,'ran_anim','x',480},
	{0,'ran_anim','y',-250},
	{0,'ran_anim','rotationz',180},
	{0,'ran_anim','diffusealpha',1},
	{0,'ran_anim','zoom',0.8},
	{0,'ran_anim','bounceend',0.2},
	{0,'ran_anim','y',50},
	{0,'ran_anim','sleep',1.1},
	{0,'ran_anim','addy',-250},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	---------------------------
	---------------------------
	{87.500},
	
	{0,'ran_anim','linear',0.1},
	{0,'ran_anim','addy',-250},
	
	---------------------------
	---------------------------
	{88.000},
	
	{0,'P1','x',160},
	{0,'P1','y',240},
	{0,'P1','decelerate',1},
	{0,'P1','rotationz',0},
	
	{0,'P2','x',480},
	{0,'P2','y',240},
	{0,'P2','decelerate',1},
	{0,'P2','rotationz',0},

	---------------------------
	---------------------------
	{104.000},
	
	{0,'P1','decelerate',0.2},
	{0,'P1','x',320},
	{0,'P1','y',SCREEN_BOTTOM},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','x',320},
	{0,'P2','y',SCREEN_BOTTOM},

	---------------------------
	---------------------------
	{105.000},
	{0,'P1','decelerate',0.2},
	{0,'P1','rotationz',25},
	{0,'P1','x',400},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','rotationz',25},
	{0,'P2','x',400},

	---------------------------
	---------------------------
	{106.000},
	
	{0,'P1','decelerate',0.2},
	{0,'P1','rotationz',-25},
	{0,'P1','x',250},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','rotationz',-25},
	{0,'P2','x',250},

	---------------------------
	---------------------------
	{107.000},
	
	{0,'P1','decelerate',0.2},
	{0,'P1','rotationz',0},
	{0,'P1','zoom',1.5},
	{0,'P1','x',320},
	{0,'P1','y',SCREEN_BOTTOM+200},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','rotationz',0},
	{0,'P2','zoom',1.5},
	{0,'P2','x',320},
	{0,'P2','y',SCREEN_BOTTOM+200},

	---------------------------
	---------------------------
	{108.000},
	
	{0,'P1','decelerate',0.2},
	{0,'P1','rotationz',0},
	{0,'P1','zoom',1},
	{0,'P1','x',160},
	{0,'P1','y',240},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','rotationz',0},
	{0,'P2','zoom',1},
	{0,'P2','x',480},
	{0,'P2','y',240},

	---------------------------
	---------------------------
	{148.000},
	
	{0,'P1','decelerate',0.5},
	{0,'P1','x',320},
	{0,'P1','y',240},
	
	{0,'P2','decelerate',0.5},
	{0,'P2','x',320},
	{0,'P2','y',240},

	---------------------------
	---------------------------
	{152.000},
	
	{0,'P1','decelerate',0.5},
	{0,'P1','addx',-37},
	
	{0,'P2','decelerate',0.5},
	{0,'P2','addx',36},

	---------------------------
	---------------------------
	{154.000},
	{0,'P1','decelerate',1},
	{0,'P1','x',160},

	
	{0,'P1','wag'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',2},
	{0,'P1','effectmagnitude',0,0,30},
	
	{0,'P2','decelerate',1},
	{0,'P2','x',480},
	{0,'P2','wag'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',2},
	{0,'P2','effectmagnitude',0,0,30},

	---------------------------
	---------------------------
	{155.000},
	{0,'P1','effectmagnitude',0,0,60},
	{0,'P2','effectmagnitude',0,0,60},

	---------------------------
	---------------------------
	{156.000},
	{0,'screen','finishtweening'},
	{0,'P1','finishtweening'},
	{0,'P2','finishtweening'},
	{0,'P1','stopeffect'},
	{0,'P2','stopeffect'},

	---------------------------
	---------------------------
	{163.000},
	{0,'color_tile','x',320},
	{0,'color_tile','y',240},
	{0,'color_tile','linear',1},
	{0,'color_tile','diffuse',0,0,1,0.5},
	
	{0,'snow1','linear',1},
	{0,'snow1','diffusealpha',1},
	{0,'snow2','linear',1},
	{0,'snow2','diffusealpha',1},
	{0,'snow3','linear',1},
	{0,'snow3','diffusealpha',1},

	---------------------------
	---------------------------
	{171.000},

	{0,'P1','decelerate',0.2},
	{0,'P1','addy',-70},
	{0,'P1','zoomx',0.6},
	{0,'P1','zoomy',1.2},
	{0,'P1','accelerate',0.2},
	{0,'P1','addy',70},
	{0,'P1','zoomx',0.8},
	{0,'P1','zoomy',0.8},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','addy',-70},
	{0,'P2','zoomx',0.6},
	{0,'P2','zoomy',1.2},
	{0,'P2','accelerate',0.2},
	{0,'P2','addy',70},
	{0,'P2','zoomx',0.8},
	{0,'P2','zoomy',0.8},

	---------------------------
	---------------------------
	{172.000},
	{0,'P1','bounce'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',0.5},
	{0,'P1','effectoffset',0.25},
	{0,'P1','effectmagnitude',0,-50,0},
	
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',60},
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',-10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',-60},
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',60},
	
	{0,'P2','bounce'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',0.5},
	{0,'P2','effectoffset',0.25},
	{0,'P2','effectmagnitude',0,-50,0},
	
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',-10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',-60},
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',60},
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',-10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',-60},

	---------------------------
	---------------------------
	{178.000},
	{0,'P1','wag'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',2},
	{0,'P1','effectoffset',0},
	{0,'P1','effectmagnitude',0,0,30},
	
	{0,'P1','decelerate',0.5},
	{0,'P1','rotationz',0},
	{0,'P1','zoom',1},
	{0,'P1','x',160},
	
	{0,'P2','wag'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',2},
	{0,'P2','effectoffset',0},
	{0,'P2','effectmagnitude',0,0,30},
	
	{0,'P2','decelerate',0.5},
	{0,'P2','rotationz',0},
	{0,'P2','zoom',1},
	{0,'P2','x',480},

	---------------------------
	---------------------------
	{180.000},
	{0,'P1','stopeffect'},
	{0,'P2','stopeffect'},

	---------------------------
	---------------------------
	{203.000},

	{0,'P1','decelerate',0.2},
	{0,'P1','addy',-70},
	{0,'P1','zoomx',0.6},
	{0,'P1','zoomy',1.2},
	{0,'P1','accelerate',0.2},
	{0,'P1','addy',70},
	{0,'P1','zoomx',0.8},
	{0,'P1','zoomy',0.8},
	
	{0,'P2','decelerate',0.2},
	{0,'P2','addy',-70},
	{0,'P2','zoomx',0.6},
	{0,'P2','zoomy',1.2},
	{0,'P2','accelerate',0.2},
	{0,'P2','addy',70},
	{0,'P2','zoomx',0.8},
	{0,'P2','zoomy',0.8},

	---------------------------
	---------------------------
	{204.000},
	{0,'P1','bounce'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',0.5},
	{0,'P1','effectoffset',0.25},
	{0,'P1','effectmagnitude',0,-50,0},
	
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',60},
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',-10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',-60},
	{0,'P1','linear',0.094},
	{0,'P1','rotationz',10},
	{0,'P1','linear',0.65},
	{0,'P1','addx',60},
	
	{0,'P2','bounce'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',0.5},
	{0,'P2','effectoffset',0.25},
	{0,'P2','effectmagnitude',0,-50,0},
	
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',-10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',-60},
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',60},
	{0,'P2','linear',0.094},
	{0,'P2','rotationz',-10},
	{0,'P2','linear',0.65},
	{0,'P2','addx',-60},

	---------------------------
	---------------------------
	{210.000},
	{0,'P1','wag'},
	{0,'P1','effectclock','bgm'},
	{0,'P1','effectperiod',2},
	{0,'P1','effectoffset',0},
	{0,'P1','effectmagnitude',0,0,30},
	
	{0,'P1','decelerate',0.5},
	{0,'P1','rotationz',0},
	{0,'P1','zoom',1},
	{0,'P1','x',160},
	
	{0,'P2','wag'},
	{0,'P2','effectclock','bgm'},
	{0,'P2','effectperiod',2},
	{0,'P2','effectoffset',0},
	{0,'P2','effectmagnitude',0,0,30},
	
	{0,'P2','decelerate',0.5},
	{0,'P2','rotationz',0},
	{0,'P2','zoom',1},
	{0,'P2','x',480},

	---------------------------
	---------------------------
	{212.000},
	{0,'P1','stopeffect'},
	{0,'P2','stopeffect'},

	---------------------------
	---------------------------
	{224.000},
	
	{0,'luna_anim','x',180},
	{0,'luna_anim','y',240},
	{0,'luna_anim','zoom',0},
	{0,'luna_anim','diffusealpha',1},
	{0,'luna_anim','linear',0.6},
	{0,'luna_anim','x',300},
	{0,'luna_anim','y',200},
	{0,'luna_anim','zoom',0.8},
	{0,'luna_anim','rotationz',750},
	{0,'luna_anim','accelerate',1.5},
	{0,'luna_anim','addy',400},
	{0,'luna_anim','sleep',0},
	{0,'luna_anim','diffusealpha',0},
	
	{0,'saph_anim','x',180},
	{0,'saph_anim','y',240},
	{0,'saph_anim','zoom',0},
	{0,'saph_anim','diffusealpha',1},
	{0,'saph_anim','linear',0.6},
	{0,'saph_anim','x',100},
	{0,'saph_anim','y',300},
	{0,'saph_anim','zoom',0.8},
	{0,'saph_anim','rotationz',-750},
	{0,'saph_anim','accelerate',1.5},
	{0,'saph_anim','addy',400},
	{0,'saph_anim','sleep',0},
	{0,'saph_anim','diffusealpha',0},
	
	{0,'sunny_anim','x',180},
	{0,'sunny_anim','y',240},
	{0,'sunny_anim','zoom',0},
	{0,'sunny_anim','diffusealpha',1},
	{0,'sunny_anim','linear',0.6},
	{0,'sunny_anim','x',550},
	{0,'sunny_anim','y',300},
	{0,'sunny_anim','zoom',0.8},
	{0,'sunny_anim','rotationz',-750},
	{0,'sunny_anim','accelerate',1.5},
	{0,'sunny_anim','addy',400},
	{0,'sunny_anim','sleep',0},
	{0,'sunny_anim','diffusealpha',0},
	
	{0,'glass_anim','x',320},
	{0,'glass_anim','y',240},
	{0,'glass_anim','rotationz',35},
	{0,'glass_anim','zoom',3},
	{0,'glass_anim','diffusealpha',0},
	{0,'glass_anim','sleep',0.6},
	{0,'glass_anim','diffusealpha',1},
	{0,'glass_anim','sleep',2},
	{0,'glass_anim','linear',1},
	{0,'glass_anim','diffusealpha',0},

	---------------------------
	---------------------------
	{228.000},
	{0,'P1','decelerate',0.3},
	{0,'P1','rotationz',20},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','rotationz',20},

	---------------------------
	---------------------------
	{232.000},
	{0,'P1','decelerate',0.3},
	{0,'P1','rotationz',-20},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','rotationz',-20},

	---------------------------
	---------------------------
	{236.000},
	{0,'P1','decelerate',0.3},
	{0,'P1','rotationz',20},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','rotationz',20},

	---------------------------
	---------------------------
	{240.000},
	
	{0,'color_tile','linear',1},
	{0,'color_tile','diffuse',0,0,1,0},
	
	{0,'snow1','linear',1},
	{0,'snow1','diffusealpha',0},
	{0,'snow2','linear',1},
	{0,'snow2','diffusealpha',0},
	{0,'snow3','linear',1},
	{0,'snow3','diffusealpha',0},
	
	{0,'P1','decelerate',1},
	{0,'P1','rotationz',0},
	
	{0,'P2','decelerate',1},
	{0,'P2','rotationz',0},

	---------------------------
	{244.000},
	
	{0,'color_tile','x',320},
	{0,'color_tile','y',240},
	{0,'color_tile','zoom',2000},
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',1,0,0,0.4},
	
	{0,'P1','decelerate',0.3},
	{0,'P1','zoom',0.8},
	{0,'P1','rotationz',25},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','zoom',0.8},
	{0,'P2','rotationz',25},

	---------------------------
	---------------------------
	{248.000},
	
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',0,0,1,0.4},
	
	{0,'P1','decelerate',0.3},
	{0,'P1','zoom',0.5},
	{0,'P1','rotationz',-25},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','zoom',0.5},
	{0,'P2','rotationz',-25},

	---------------------------
	---------------------------
	{252.000},
	
	{0,'color_tile','decelerate',0.3},
	{0,'color_tile','diffuse',0,1,0,0.4},
	
	{0,'P1','decelerate',0.3},
	{0,'P1','zoom',0.3},
	{0,'P1','rotationz',25},
	
	{0,'P2','decelerate',0.3},
	{0,'P2','zoom',0.3},
	{0,'P2','rotationz',25},

	---------------------------
	---------------------------
	{255.500},
	{0,'color_tile','linear',1},
	{0,'color_tile','diffuse',1,1,1,0},
	
	{0,'P1','decelerate',0.187},
	{0,'P1','rotationz',0},
	{0,'P1','decelerate',1},
	{0,'P1','zoom',1},
	
	{0,'P2','decelerate',0.187},
	{0,'P2','rotationz',0},
	{0,'P2','decelerate',1},
	{0,'P2','zoom',1},

	---------------------------
	---------------------------
	{260.000},
	
	{0,'pa','diffusealpha',1},
	{0,'pa','zoom',1},
	{0,'pa','x',480},
	{0,'pa','y',300},
	{0,'pa','decelerate',1},
	{0,'pa','addy',100},
	{0,'pa','diffusealpha',0},
	
	{0,'chen_anim','x',480},
	{0,'chen_anim','y',-200},
	{0,'chen_anim','rotationz',180},
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','zoom',0.8},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',50},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-200},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	{0,'P1','rotationz',25},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	{0,'P2','rotationz',25},

	---------------------------
	---------------------------
	{263.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-250},
	
	---------------------------
	---------------------------
	{264.000},
	
	{0,'pi','diffusealpha',1},
	{0,'pi','zoom',1},
	{0,'pi','x',160},
	{0,'pi','y',200},
	{0,'pi','decelerate',1},
	{0,'pi','addy',-100},
	{0,'pi','diffusealpha',0},
	
	{0,'chen_anim','x',160},
	{0,'chen_anim','y',680},
	{0,'chen_anim','rotationz',0},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',400},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',220},
	
	{0,'P1','x',640},
	{0,'P1','y',SCREEN_TOP-240},
	
	{0,'P2','x',640},
	{0,'P2','y',SCREEN_TOP-240},
	

	---------------------------
	---------------------------
	{267.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',250},
	
	---------------------------
	---------------------------
	{268.000},
	
	{0,'pu','diffusealpha',1},
	{0,'pu','zoom',1},
	{0,'pu','x',480},
	{0,'pu','y',300},
	{0,'pu','decelerate',1},
	{0,'pu','addy',100},
	{0,'pu','diffusealpha',0},
	
	{0,'chen_anim','x',480},
	{0,'chen_anim','y',-200},
	{0,'chen_anim','rotationz',180},
	{0,'chen_anim','diffusealpha',1},
	{0,'chen_anim','zoom',0.8},
	{0,'chen_anim','bounceend',0.2},
	{0,'chen_anim','y',50},
	{0,'chen_anim','sleep',1.1},
	{0,'chen_anim','addy',-200},
	
	{0,'P1','x',SCREEN_LEFT},
	{0,'P1','y',SCREEN_BOTTOM+200},
	
	{0,'P2','x',SCREEN_LEFT},
	{0,'P2','y',SCREEN_BOTTOM+200},
	---------------------------
	---------------------------
	{271.500},
	
	{0,'chen_anim','linear',0.1},
	{0,'chen_anim','addy',-250},
	
	---------------------------
	---------------------------
	{272.000},
	
	{0,'P1','x',160},
	{0,'P1','y',240},
	{0,'P1','decelerate',1},
	{0,'P1','rotationz',0},
	
	{0,'P2','x',480},
	{0,'P2','y',240},
	{0,'P2','decelerate',1},
	{0,'P2','rotationz',0},
	---------------------------
	
	
}

local curmessage = 1
local messages = {
	
	{0.100,'Center'},
	{4.000,'Shakeyshakey'},
	{8.000,'Shakeyshakey'},
	{12.000,'Shakeyshakey'},
	{20.000,'Uncenter'},
	
	-- Cirno's cute dance --
	
	{20.000,'Stuff'},
	{21.000,'Bump'},
	{22.000,'Bump'},
	{23.000,'Bump'},
	
	{25.000,'Bump'},
	{26.000,'Bump'},
	{27.000,'Bump'},
	
	{29.000,'Bump'},
	{30.000,'Bump'},
	{31.000,'Bump'},
	
	{32.000,'Yeahhh'},
	
	-- Dai-chan's cute dance --
	
	{77.000,'Bump'},
	{78.000,'Bump'},
	{79.000,'Bump'},
	
	{81.000,'Bump'},
	{82.000,'Bump'},
	{83.000,'Bump'},
	
	{85.000,'Bump'},
	{86.000,'Bump'},
	{87.000,'Bump'},
	
	{88.000,'Yeahhh'},
	
	{171.000,'Woo'},
	{203.000,'Woo'},
	
	
	{224.000,'ShakeBoom'},
	
	{244.000,'Shakeyshakey'},
	{248.000,'Shakeyshakey'},
	{252.000,'Shakeyshakey'},
	
	
	{261.000,'Bump'},
	{262.000,'Bump'},
	{263.000,'Bump'},
	
	{265.000,'Bump'},
	{266.000,'Bump'},
	{267.000,'Bump'},
	
	{269.000,'Bump'},
	{270.000,'Bump'},
	{271.000,'Bump'},
	
	{272.000,'Yeahhh'},
	
	
}

local function update(frame, delta)
	local beat= GAMESTATE:GetSongBeat()

	-- VIBRATION CONTROL --
	screen_gameplay:vibrate()
	screen_gameplay:effectmagnitude(vib_ctrl,vib_ctrl,0)
	-- vib_ctrl originally decayed by 1.6 every update, with 50Hz update time.
	-- That works out to 80 per second. -Kyz
	vib_ctrl = vib_ctrl - (80 * delta)
	if vib_ctrl < 0 then vib_ctrl = 0 end

	-- BUMP CONTROL -- 	
	
	if beat > 108 + bump_ctrl[1] and beat < 148 then
		MESSAGEMAN:Broadcast('Drunk');
		bump_ctrl[1] = bump_ctrl[1] + 0.5
	end
	
	if beat > 164.5 + bump_ctrl[2] and beat < 212 then
		MESSAGEMAN:Broadcast('Speed');
		bump_ctrl[2] = bump_ctrl[2] + 1
	end
	
	if beat > 36 + bump_ctrl[3] and beat < 68 or beat > 92 + bump_ctrl[3] and beat < 124 then
		MESSAGEMAN:Broadcast('TreeBump');
		bump_ctrl[3] = bump_ctrl[3] + 1
	end
	

	-- BEAT SPECIFIC ACTIONS -- 

	if beat > 69 and cur_fg == 1 then bump_ctrl[3] = 0; cur_fg = cur_fg + 1; end
	--------------------------------------------------------------------------------------------------------------------------
	---------------------------------------- /!\ DANGER! FALLOUT ZONE! DO NOT ENTER /!\ --------------------------------------
	--------------------------------------------------------------------------------------------------------------------------
	
	
	-- Beat based mod reader by TaroNuke -- 
	if curmod <= #mods and beat >= mods[curmod][1] then
		local mod_data= mods[curmod]
		if mod_data ~= nil then
			if #mod_data == 3 then
				poptions[mod_data[3]]:FromString(mod_data[2])
			else
				mod_both(mod_data[2])
			end
			curmod = curmod+1;
		end
	end
	
	-- SCREAMING GUMBALL by TaroNuke -- 
	if curmessage <= #messages and beat >= messages[curmessage][1] then
		if messages[curmessage][3] and messages[curmessage][3] == true and beat < messages[curmessage][1]+5
		or not messages[curmessage][3] then 
			MESSAGEMAN:Broadcast(messages[curmessage][2]);
		end
		curmessage = curmessage+1;
	end
	
	-- Anything Eater by Taronuke --
	while cura <= #anything and anything[cura] and beat >= anything[cura][1] do
		local action= anything[cura]
		if action[2] == 'SystemMessage' then
			SCREENMAN:SystemMessage(action[3])
		elseif anything_actors[action[2]] then
			-- The list of every actor function was woefully misguided. -Kyz
			local actor= anything_actors[action[2]]
			local command= action[3]
			if actor[command] then
				actor[command](actor, action[4], action[5], action[6], action[7])
			end
			-- That's it.  That's all you need.  You don't need an if condition for
			-- every actor function.
		end
		cura = cura+1;
	end
end

local frame= Def.ActorFrame{
	Def.Actor{InitCommand= function(self) self:sleep(999) end},
	OnCommand= function(self)
		self:SetUpdateFunction(update)
		screen_gameplay= SCREENMAN:GetTopScreen()
		for i, pn in ipairs(GAMESTATE:GetEnabledPlayers()) do
			local short_pn= ToEnumShortString(pn)
			local pactor= screen_gameplay:GetChild("Player"..short_pn)
			if pactor then
				anything_actors[short_pn]= pactor
				anything_actors["score"..short_pn]= screen_gameplay:GetChild("Score"..short_pn)
				anything_actors["life"..short_pn]= screen_gameplay:GetChild("Life"..short_pn)
				anything_actors["judge"..short_pn]= pactor:GetChild("Judgment")
				anything_actors["combo"..short_pn]= pactor:GetChild("Combo")

				anything_actors["score"..short_pn]:visible(false)
				anything_actors["life"..short_pn]:visible(false)

				-- Add options by 0-based index because that's what was probably used
				-- in oitg. -Kyz
				poptions[PlayerNumber:Reverse()[pn]]= GAMESTATE:GetPlayerState(pn):GetPlayerOptions("ModsLevel_Song")
			end
		end
		anything_actors.songbackground= screen_gameplay:GetChild('SongBackground')
		anything_actors.overlay= screen_gameplay:GetChild("Overlay")
		anything_actors.underlay= screen_gameplay:GetChild("Underlay")
		anything_actors.overlay:visible(false)
		anything_actors.underlay:visible(false)
		anything_actors.screen= screen_gameplay

		-- Put a wrapper around the screen so it can be rotated around its center
		-- instead of rotating around the upper left corner.
		local wrapper= screen_gameplay:AddWrapperState()
		wrapper:xy(_screen.cx, _screen.cy)
		screen_gameplay:xy(-_screen.cx, -_screen.cy)
	end,
	TreeBumpMessageCommand= function(self)
		anything_actors.tree_anim:stoptweening()
			:linear(0.05):addy(20):zoomy(0.8)
			:linear(0.2):addy(-20):zoomy(1)
	end,
	BumpMessageCommand= function(self)
		anything_actors.chen_anim:stoptweening()
			:linear(0.1):addy(40)
			:linear(0.1):addy(-40)

		anything_actors.ran_anim:stoptweening()
			:linear(0.1):addy(40)
			:linear(0.1):addy(-40)
		for i, pname in ipairs{"P1", "P2"} do
			if anything_actors[pname] then
				anything_actors[pname]:stoptweening()
					:linear(0.1):zoomy(0.9)
					:linear(0.1):zoomy(1)
			end
		end
	end,
	CenterMessageCommand= function(self)
		-- Disabled because it was replaced by using wrappers. -Kyz
		do return end
		anything_actors.screen:xy(cx, cy)
		anything_actors.songbackground:addx(-cx):addy(-cy)
		anything_actors.overlay:visible(false)
		anything_actors.underlay:visible(false)
		
		for i, pname in ipairs{"P1", "P2"} do
			if anything_actors[pname] then
				anything_actors["life"..pname]:visible(false)
				anything_actors["score"..pname]:visible(false)
				anything_actors[pname]:addx(-cx):addy(-cy)
			end
		end
	end,
	UncenterMessageCommand= function(self)
		-- Disabled because it was replaced by using wrappers. -Kyz
		do return end
		anything_actors.screen:xy(0, 0)
		anything_actors.songbackground:addx(cx):addy(cy)
	end,
	DrunkMessageCommand= function(self)
		mod_both('*20 100 drunk')
		if GAMESTATE:GetSongBeat() < 124 then
			mod_both('*10000 50 stealth')
		end
		self:sleep(0.094):queuecommand('Drunk2')
	end,
	Drunk2Command= function(self)
		mod_both('*20 -100 drunk')
		if GAMESTATE:GetSongBeat() < 124 then
			mod_both('*10000 0 stealth')
		end
	end,
	SpeedMessageCommand= function(self)
		anything_actors.sun:stoptweening()
			:linear(0.1):zoom(7)
			:decelerate(0.2):zoom(3)
		if oscillate == 1 then
			mod_both('*7 1.5x')
			oscillate = 2;
		elseif oscillate == 2 then
			mod_both('*7 2.3x')
			oscillate = 1;
		end
	end,
	ShakeyshakeyMessageCommand= function(self)
		vib_ctrl = 30;
	end,
	ShakeBoomMessageCommand= function(self)
		vib_ctrl = 40;
		SOUND:PlayOnce(path..'BG/bang.ogg');
	end,
	YeahhhMessageCommand= function(self)
		anything_actors.yeah_anim:diffusealpha(1):xy(1500, 240):zoom(5)
			:linear(1.5):x(-1000):sleep(0):diffusealpha(0)

		anything_actors.chen_anim:diffusealpha(1):zoom(1):x(800, 150):rotationz(-10)
			:linear(0.2):x(200)
			:linear(1.3):x(160)
			:linear(0.2):x(-150)
			:sleep(0):diffusealpha(0)

		anything_actors.ran_anim:diffusealpha(1):zoom(1):zoomx(-1):x(-150, 350):rotationz(-10)
			:linear(0.2):x(400)
			:linear(1.3):x(480)
			:linear(0.2):x(800)
			:sleep(0):diffusealpha(0)
	end,
}

if false then
	frame[#frame+1]= Def.ActorFrame{
		InitCommand= function(self)
			self:SetUpdateFunction(
				function()
					if vib_ctrl > 0 then
						SCREENMAN:SystemMessage("vibrator: " .. vib_ctrl)
					end
			end)
		end,
	}
end

return frame
